#####################################################################
#
#       Copyright : Roshan Kumar Singh <singh.roshan08@gmail.com>
#       Licenced under GPLv2 or later.
#       Copyright: See License file that comes with this distribution
#
#####################################################################
from Blog import Blog, Post

class Wordpress(Blog):
	'''Class for wordpress blogs.'''
	post = Post()
	def __init__(self, url, username, password, proxyEnable, host, port, proxyUsername, proxyPassword, blogType):
		Blog.__init__(self, url, username, password, proxyEnable, host, port, proxyUsername, proxyPassword, blogType)
		

	def getCategories(self):
		self.postedCategory = []
		try:
			cat = self.server.wp.getCategories(1, self.username, self.password)
			if cat:
				for c in cat:
					self.postedCategory.append(c['description'])
			return True
		except:
			return False
		

	def getRecentPosts(self):
		try:
			post = self.server.metaWeblog.getRecentPosts(1, self.username, self.password)
			self.posts = []
			if post:
				for p in post:
					self.posts.append({'title' : p['title'], 'postid' : p['postid']})
			return True
		except:
			return False

	
	def getPost(self, postId):
		try:	
			post = self.server.metaWeblog.getPost(postId , self.username, self.password)
			p = Post()
			self.post.postId = postId
			p.title = post['title']
			p.body = post['description']
			p.category = post['categories']
			p.tags = post['mt_keywords']
			return p
		except:
			return False

	def addCategory(self, newCategory):
		newCategory = {'name':newCategory}
		try:
			self.server.wp.newCategory(1, self.username, self.password, newCategory)
			return True
		except:
			return False

	def newPost(self, blogPost):
		'''Create a new post'''
		try:
			postId = int(self.server.metaWeblog.newPost(1, self.username, self.password, blogPost,0))	
			self.post.postId = postId
			return True
		except:
			return False

	def publishPost(self):
		'''Publishes a posted content'''
		try:
			ret = self.server.mt.publishPost(self.post.postId, self.username, self.password, 1)
			self.post.isPublished = 1
			return True
		except:
			return False
	
	def editPost(self, blogPost):
		try:
			self.server.metaWeblog.editPost(self.post.postId, self.username, self.password, blogPost, self.post.isPublished)
			return True
		except:
			return False		

	def addPage(self, page):
		try:
			res = self.server.wp.newPage(1, self.username, self.password, page, 1)
			return True
		except:
			return False
		
