# This file is taken from http://antrix.net/stuff/writr/ project. Provides a very nice and useful 
# way to parse HTML for good visual display.
# Licensed under GNU GPL. 
# Modified to use webkit instead of the dead gtkhtml2 python code.

import traceback
import webkit
from markdown import markdown

class HtmlView(webkit.WebView):
    
    def __init__(self):
        webkit.WebView.__init__(self)

    def update(self, text, parent):
        try:
            fmt_text = markdown(text.encode("utf-8"))
        except:
            traceback.print_exc()
            fmt_text =  "<h3>Markdown conversion failed!</h3>" \
                     +  "The following error was encountered:<br/><br/>"
            tb_str   =  traceback.format_exc()
            fmt_text += "<code><pre>%s</pre></code>" % tb_str

        header_text = u"""<html><head>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
            <title>Try</title>
            </head>
            <body bgcolor="#CCCCFF">"""
        footer_text = u"</body></html>"

        whole_text = header_text
        whole_text += fmt_text
        whole_text += footer_text

        self.load_string(whole_text, "text/html", "utf-8", "file:/")
